package modelo.planetas;

import modelo.Contribuyente;
import modelo.FondoDeContribucion;
import modelo.aportes.AportePorcentual;

public class PlanetaAgricola implements Contribuyente {

    private int produccionPorHabitante;
    private int poblacion;

    public PlanetaAgricola(int produccionPorHabitante, int poblacion) {
        this.produccionPorHabitante = produccionPorHabitante;
        this.poblacion = poblacion;
    }

    private int producir() {
        return this.produccionPorHabitante * this.poblacion;
    }

    @Override
    public void contribuir(FondoDeContribucion fondoDeContribucion) {
        int produccion = this.producir();
        AportePorcentual aporte = new AportePorcentual(produccion,0.5);
        fondoDeContribucion.recibirContribucion(aporte);
    }
}
