package modelo.planetas;

import modelo.Contribuyente;
import modelo.FondoDeContribucion;
import modelo.aportes.AportePorcentual;

public class PlanetaMinero implements Contribuyente {

    private int poblacion;

    public PlanetaMinero(int poblacion) {
        this.poblacion = poblacion;
    }

    private int producir() {
        return this.poblacion/2;
    }

    @Override
    public void contribuir(FondoDeContribucion fondoDeContribucion) {
        int produccion = this.producir();
        AportePorcentual aporte = new AportePorcentual(produccion,0.3);
        fondoDeContribucion.recibirContribucion(aporte);
    }
}
