package test;

import modelo.Contribuyente;
import modelo.Imperio;
import modelo.planetas.PlanetaAgricola;
import modelo.planetas.PlanetaMinero;
import modelo.planetas.PlanetaSimuladores;
import org.junit.Assert;
import org.junit.Test;

public class ImperioTest {

    double delta = 1e-15;

    @Test
    public void imperioSinPlanetasNoObtieneRemesaDeProduccion() {
        Imperio imperio = new Imperio();
        Assert.assertEquals(0, imperio.solicitarRemesaDeProduccion(), delta);
    }

    @Test
    public void imperioConUnPlanetaAgricolaObtiene50PorcientoRemesaDeProduccionDeEsePlaneta() {
        Imperio imperio = new Imperio();
        Contribuyente tierra = new PlanetaAgricola(10, 100);
        imperio.agregarPlaneta(tierra);
        Assert.assertEquals(500, imperio.solicitarRemesaDeProduccion(), delta);
    }

    @Test
    public void imperioConUnPlanetaMineroConOroObtiene30PorcientoRemesaDeProduccionDeEsePlaneta() {
        Imperio imperio = new Imperio();
        Contribuyente planetaMinero = new PlanetaMinero( 100);
        imperio.agregarPlaneta(planetaMinero);
        Assert.assertEquals(15, imperio.solicitarRemesaDeProduccion(), delta);
    }

    @Test
    public void imperioConUnPlanetaMineroYUnoAgricolaObtieneRemesaDeProduccionDeAmbosPlanetas() {
        Imperio imperio = new Imperio();
        Contribuyente planetaAgricola = new PlanetaAgricola(10, 100);
        Contribuyente planetaMinero = new PlanetaMinero( 100);
        imperio.agregarPlaneta(planetaAgricola);
        imperio.agregarPlaneta(planetaMinero);
        Assert.assertEquals(515, imperio.solicitarRemesaDeProduccion(), delta);
    }


    @Test
    public void imperioConPlanetaAgricolaYSimuladoresObtieneMitadRemesaDeProduccion() {

        Imperio imperio = new Imperio();
        Contribuyente tierra = new PlanetaAgricola(10, 100);
        imperio.agregarPlaneta(tierra);

        Contribuyente losSimuladores = new PlanetaSimuladores();
        imperio.agregarPlaneta(losSimuladores);

        Assert.assertEquals(250, imperio.solicitarRemesaDeProduccion(), delta);
    }
}
